<?

/*
 * Warning ** Warning ** Warning ** Warning ** Warning ** Warning *
 *                                                                *
 * -> this webinterface is ment to be a sample implementation  <- *
 *                                                                *
 * Warning ** Warning ** Warning ** Warning ** Warning ** Warning *
 *
 *
 * Copyright (C) 2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/**
 * Webinterface for squidwall
 *
 * ctime: 2006-04-08
 * mtime: 2006-08-06
 *
 * Beschreibung:
 * - hier landen alle wichtigen Funktionen
 */

/* Funktion zum Beenden einer Anfrage */
function print_foot() {
	echo "</body></html>";
	exit;
}

function fatal_error($a="") {
	global $P_INT;
	include("$P_INT/HEAD");
	echo $a;
	print_foot();
}

/**
 * use it like:
 *
 * $t="@4000000044c519ad33e0dc60";
 * list($s,$n) = tai64n_decode($t);
 * $x = date("Y-m-d H:i:s", $s);
 * echo "$t => $s.$n ($x)";
*/
function tai64n_decode($tai64n) {
  $secs = 0;
  $nano = 0;

  if (substr($tai64n, 0, 9) == '@40000000') {
    $secs = hexdec(substr($tai64n,9,8));
    $nano = hexdec(substr($tai64n,17,8));
  }

  return array ($secs,$nano);
}

function my_rename($dir, $file, $pold, $pnew) {
	global $changed;
	rename($dir."/"."$pold$file", $dir."/"."$pnew$file");
	$changed=1;
	return;
}

/* for my_edit_hosts() */
function my_touch($dir, $file, $p) {
	global $changed;
	touch($dir."/"."$p$file");
	$changed=1;
	return;
}

/* touches, renames files as wanted */
function my_edit_acls($dir2save, $filename) {
	global $changed, $group;
	
	$f=file($filename);
	$sel_access_prefix = array ("+", "?", "-");
	
	for($i=0; isset($f[$i]); $i++) {
		$e=chop($f[$i]);
		$x=$_POST["$group$i"];    /* die zahl: 1..3 -> 0..2 */
		$c=$sel_access_prefix[$x-1]; /* '+' '?' '-' */
		$changed=0;
		
		switch ($c) {
		case "+":
			if (is_file($dir2save . "/?" . $e)) {
				my_rename($dir2save, "$e", "?", "+");
				break;
			}
			if (is_file($dir2save . "/-" . $e)) {
				my_rename($dir2save, "$e", "-", "+");
				break;
			}
			if (!is_file($dir2save . "/+" . $e)) {
				my_touch($dir2save, "$e", "+");
				break;
			}
			break;
		case "?":
			if (is_file($dir2save . "/+" . $e)) {
				my_rename($dir2save, "$e", "+", "?");
				break;
			}
			if (is_file($dir2save . "/-" . $e)) {
				my_rename($dir2save, "$e", "-", "?");
				break;
			}
			if (!is_file($dir2save . "/?" . $e)) {
				my_touch($dir2save, "$e", "?");
				break;
			}
			break;
		case "-":
			if (is_file($dir2save . "/?" . $e)) {
				my_rename($dir2save, "$e", "?", "-");
				break;
			}
			if (is_file($dir2save . "/+" . $e)) {
				my_rename($dir2save, "$e", "+", "-");
				break;
			}
			if (!is_file($dir2save . "/-" . $e)) {
				my_touch($dir2save, "$e", "-");
				break;
			}
			break;
		default:
			break;
		}
		
		/* die Datei '!' wird durch squidwall geprft */
		if ($changed == 1) {
			touch("$dir2save/!");
		}
	}
}

/**
 * touches or renames files as wanted
 */
function my_edit_options($path, $name) {
	if (is_file($path . "/+" . $name)) {
		my_rename($path, $name, "+", "?");
	}
	if (is_file($path . "/-" . $name)) {
		my_rename($path, $name, "-", "?");
	}
	if (!is_file($path . "/?" . $name)) {
		my_touch($path, $name, "?");
	}
}

/**
 * edit/create some file from textarea input
 */
function my_edit_filters($path, $todo) {
	for ($k=0; isset($todo[$k]); $k++) {
		$defs = $_POST["defs$k"];
		$defs = str_replace("\r\n", "\n", $defs);
		$f=fopen("$path/".$todo[$k][0],"w");
		fwrite($f, $defs, strlen($defs));
		fclose($f);
	}
	touch("$path/!");
}

/**
 * edit/create some file from textarea input
 */
function my_edit_defs($filename) {
	$defs = $_POST['defs'];
	if (!is_file($filename)) { return; }
	$f=fopen("$filename","w");
	$defs = str_replace("\r\n", "\n", $defs);
	fwrite($f, $defs, strlen($defs));
	fclose($f);
}

/**
 * init_defs(path,array)
 */
function init_defs($path, &$array) {
	$dh=opendir($path);
	while ($file = readdir($dh)) {
		if (!is_file("$path/$file")) { continue; }
		$array[] = $file;
	}
	closedir($dh);
	
	if (!is_array($array)) {
		fatal_error("
		<h3>Not enough users or hosts @ <u>$path</u> defined !</h3><p>
		Just do something like:
<pre>
For Host Setup:
echo \"host1\" >> $path/room1
echo \"host2\" >> $path/room1
echo \"ip3\"   >> $path/room1
echo \"ip4\"   >> $path/room2
echo \"hostX\" >> $path/roomX

For User Setup:
echo \"-\"     >> $path/squid-default-user
echo \"user1\" >> $path/room1
echo \"user2\" >> $path/room1
echo \"user3\" >> $path/room1
</pre>
		");
	}

	sort($array);
	reset($array);
	
	return 1;
}

/**
 * init_filterdir(path,array)
 *
 * @param path   eg $P_BFILTER
 * @param array  eg $BF
 */
function init_filterdir($path, &$array) {
	global $P_FILTER;
	$path = "$P_FILTER/$path";
	if (!is_dir($path)) return;
	$dh=opendir($path);
	while ($file = readdir($dh)) {
		if (!is_file("$path/$file")) { continue; }
		if ($file == "!" || $file == "@" || $file == "README") {
			continue;
		}
		$array[] = $file;
	}
	closedir($dh);
	
	if (count($array)) {
		sort($array);
		reset($array);
		return 1;
	}

	return 0;
}

/**
 * init_redirects(path,array)
 *
 * @param path         path of the redirect directory
 * @param array_files  this array is filled with the found symlink names
 * @param array_links  this array gets the destination of the symlinks
 */
function init_redirects(&$path, &$array_files, &$array_links) {
	if (!is_dir($path)) return;
	$dh=opendir($path);
	while ($file = readdir($dh)) {
		if (!is_link("$path/$file")) { continue; }
		if ($file == "!" || $file == "@" || $file == "README") {
			continue;
		}
		$array_files[] = $file;
		$array_links[] = readlink("$path/$file");
	}
	closedir($dh);
}

/**
 * check_redirect(path,name,dest)
 *
 * @param path    path of the redirect directory
 * @param name    name of some redirect
 * @param dest    destination of some redirect
 * @param i       redirect number, which is affected
 */
function check_redirect($path, $name, $dest) {
	global $check_chg, $check_del, $i;
	global $REDIR_names, $REDIR_links;

	if (!is_dir($path)) return;

	$n=$REDIR_names[$i];
	$l=$REDIR_links[$i];

	if ($name == "" || $dest == "") {
		/* we have to delete some redirect */
		echo "$check_del $n<br>";
		unlink("$path/$n");
		touch("$path/!");
		return;
	}

	/* check, if the link has changed */
	if ($n != $name || $l != $dest) {
		echo "$check_chg $name -> $dest<br>";
		unlink("$path/$n");
		symlink("$dest", "$path/$name");
		touch("$path/!");
	}
}

/**
 * add_redirect(path,name,dest)
 *
 * @param path    path of the redirect directory
 * @param name    name of some redirect
 * @param dest    destination of some redirect
 */
function add_redirect($path, $name, $dest) {
	global $check_add;

	if (!is_dir($path)) return;

	if ($name == "") return;
	if ($dest == "") return;

	/* add new link */
	echo "$check_add $path/$name -> $dest<br>";
	symlink("$dest", "$path/$name");
	touch("$path/!");
}

/**
 * chg_user(name,pass,admin,oldname)
 *
 * @param name    name of the new user
 * @param pass    new password
 * @param admin   should the user have adminrights
 * @param oldname old username, which should be in the db
 */
function chg_user($name, $pass, $admin, $oldname) {
	global $F_AUTH;

	if (!is_writeable($F_AUTH)) return;
	if ($oldname == "") return;
	if ($name == "") return;
	if ($pass == "") return;

	/* add new link */
	$db_old=file($F_AUTH);
	for ($i=0; $i < count($db_old); $i++) { /* fr alle zeilen */
		if ($db_old[$i][0] == '#') { /* skip comments */
			$db_new[] = $db_old[$i]; continue;
		}
		list($user, $hash, $perms) = explode(':', $db_old[$i]);

		/* skip invalid lines */
		if (!isset($user)) { $db_new[] = $db_old[$i]; continue; }
		if (!isset($hash)) { $db_new[] = $db_old[$i]; continue; }
		if (!isset($perms)) { $db_new[] = $db_old[$i]; continue; }
		$perms=trim($perms);

		/* this line should change! */
		if ($user == $oldname) {
			$hash = sha1("$name:$pass");
			if (isset($admin)) { $type="a"; } else { $type="u"; }
			$x = "$name:$hash:$type\n";
			$db_new[] = $x;
			continue;
		}
		$db_new[] = $db_old[$i];
	}
	
	$f=fopen("$F_AUTH","w");
	for ($i=0; $i < count($db_new); $i++) {
		fwrite($f, $db_new[$i], strlen($db_new[$i]));
	}
	fclose($f);
}

/**
 * add_user(name,pass,admin)
 *
 * @param name    name of the new user
 * @param pass    new password
 * @param admin   should the user have adminrights
 */
function add_user($name, $pass, $admin) {
	global $F_AUTH;

	if (!is_writeable($F_AUTH)) return;
	if ($name == "") return;
	if ($pass == "") return;

	/* add new link */
	$db_old=file($F_AUTH);
	for ($i=0; $i < count($db_old); $i++) { /* fr alle zeilen */
		if ($db_old[$i][0] == '#') { /* skip comments */
			$db_new[] = $db_old[$i]; continue;
		}
		list($user, $hash, $perms) = explode(':', $db_old[$i]);

		/* skip invalid lines */
		if (!isset($user)) { $db_new[] = $db_old[$i]; continue; }
		if (!isset($hash)) { $db_new[] = $db_old[$i]; continue; }
		if (!isset($perms)) { $db_new[] = $db_old[$i]; continue; }
		$perms=trim($perms);

		/* this line should change! */
		if ($user == $name) {
			$hash = sha1("$name:$pass");
			if (isset($admin)) { $type="a"; } else { $type="u"; }
			$x = "$name:$hash:$type\n";
			$db_new[] = $x;
			$user_added=1;
			continue;
		}

		$db_new[] = $db_old[$i];
	}
	
	if (!isset($user_added)) {
		// echo "add_user([$name], [$pass], [$admin]) APPEND<br>";
		/* append to file, if a user is added */
		$hash = sha1("$name:$pass");
		if (isset($admin)) { $type="a"; } else { $type="u"; }
		$x = "$name:$hash:$type\n";
		$f=fopen("$F_AUTH","a");
		fwrite($f, $x, strlen($x));
	} else {
		// echo "add_user([$name], [$pass], [$admin]) REWRITE<br>";
		/* rewrite whole file, if a user has changed */
		$f=fopen("$F_AUTH","w");
		for ($i=0; $i < count($db_new); $i++) {
			fwrite($f, $db_new[$i], strlen($db_new[$i]));
		}
	}
	fclose($f);
}

/**
 * del_user(name)
 *
 * @param name    name of the user to delete
 */
function del_user($name) {
	global $F_AUTH;

	if (!is_writeable($F_AUTH)) return;
	if ($name == "") return;

	/* add new link */
	$db_old=file($F_AUTH);
	for ($i=0; $i < count($db_old); $i++) { /* fr alle zeilen */
		if ($db_old[$i][0] == '#') { /* skip comments */
			$db_new[] = $db_old[$i]; continue;
		}
		list($user, $hash, $perms) = explode(':', $db_old[$i]);

		/* skip invalid lines */
		if (!isset($user)) { $db_new[] = $db_old[$i]; continue; }
		if (!isset($hash)) { $db_new[] = $db_old[$i]; continue; }
		if (!isset($perms)) { $db_new[] = $db_old[$i]; continue; }
		$perms=trim($perms);

		/* this line should change! */
		if ($user == $name) { continue; }
		$db_new[] = $db_old[$i];
	}

	$f=fopen("$F_AUTH","w");
	for ($i=0; $i < count($db_new); $i++) {
		fwrite($f, $db_new[$i], strlen($db_new[$i]));
	}
	fclose($f);
}

/**
 * my_isset(var,val)
 */
function my_isset(&$variable, &$value) {
	return (($variable & $value) == $value);
}

?>
